#ifndef DATAMAP_HH
#define DATAMAP_HH

#include <cstdlib>
#include <iostream>

//DataMap class
template <class Name, class Data>
class DataMap : public std::map<Name, Data>
{
public:
  DataMap() : std::map<Name, Data>(){}
  ~DataMap(){}
  
  void Input(Name s, Data d);
  Data Output(Name s);
  typename DataMap<Name, Data>::iterator Find(Name s);
};

template <class Name, class Data>
inline void DataMap<Name, Data>::Input(Name s, Data d)
{
  typename DataMap<Name, Data>::iterator it = this->find(s);
  if(it == this->end()){
    this->insert(typename DataMap<Name, Data>::value_type(s, d));
  }else{
    (*this)[s] = d;
  }
}

template <class Name, class Data>
inline Data DataMap<Name, Data>::Output(Name s)
{
  typename DataMap<Name, Data>::iterator it = this->find(s);
  try{
    if(it == this->end()){
      throw(("\n********************\n\n" + s + " doesn't exist\n\n**********************\n").c_str());
    }
  }catch(const char* str){
    std::cout << str << std::endl;
    exit(-1);
  }
  return it->second;
}      

template <class Name, class Data>
inline typename DataMap<Name, Data>::iterator DataMap<Name, Data>::Find(Name s)
{
  typename DataMap<Name, Data>::iterator it = this->find(s);
  try{
    if(it == this->end()){
      throw(("\n********************\n\n" + s + " doesn't exist\n\n**********************\n").c_str());
    }
  }catch(const char* str){
    std::cout << str << std::endl;
    exit(-1);
  }
  return it;
}      

#endif
